"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _apolloServerLambda = require("apollo-server-lambda");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function toBool(value) {
  if (typeof value === "string") {
    return value === "true";
  }

  return Boolean(value);
}

function normalizeEvent(event) {
  // In AWS, when enabling binary support, received body gets base64 encoded. Did not find a way to solve this
  // correctly, so for now we "normalize" the event before passing it to the handler. It would be nice if
  // we could resolve this issue better / smarter in the future (configure integrations correctly?).
  if (event.isBase64Encoded) {
    event.body = Buffer.from(event.body, "base64").toString("utf-8");
  }
}

var _default = (options = {}) => {
  return {
    name: "create-apollo-handler",
    type: "create-apollo-handler",

    create({
      plugins,
      schema
    }) {
      const {
        server = {},
        handler = {}
      } = options;
      const apollo = new _apolloServerLambda.ApolloServer(_objectSpread({
        introspection: toBool(server.introspection),
        playground: toBool(server.playground),
        debug: toBool(process.env.DEBUG)
      }, server, {
        schema,
        context: async ({
          event
        }) => ({
          event,
          plugins
        })
      }));
      const apolloHandler = apollo.createHandler({
        cors: _objectSpread({
          origin: "*",
          methods: "GET,HEAD,POST"
        }, handler.cors || {})
      });
      return (event, context) => {
        normalizeEvent(event);
        return new Promise((resolve, reject) => {
          apolloHandler(event, context, (error, data) => {
            if (error) {
              return reject(error);
            }

            resolve(data);
          });
        });
      };
    }

  };
};

exports.default = _default;
//# sourceMappingURL=index.js.map